SPOJ QTREE7

题意

一棵树,每个点初始有个点权和颜色
\(0 \ u\) :询问所有\(u,v\) 路径上的最大点权,要满足\(u,v\) 路径上所有点的颜色都相同
$1 ?u \(:反转\)u$ 的颜色
\(2 \ u \ w\) :把\(u\) 的点权改成\(w\)
\(color_i∈[0,1],w_i∈[?10^9,10^9],n,m≤10^5\)

Sol

\(LCT\)
和\(QTREE6\)一样,黑白两棵\(LCT\)
不过这次我们用数据结构维护虚子树内的最大权的同色点
可以用\(multiset\),但我还是习惯可删除的\(priority\_queue\)
然后每个点维护一下所有子树的最大权的同色点

# include <bits/stdc++.h>
# define RG register
# define IL inline
# define Fill(a, b) memset(a, b, sizeof(a))
using namespace std;
typedef long long ll;
const int _(1e5 + 5);
const int INF(2e9);
typedef int Arr[_];

IL int Input(){
    RG int x = 0, z = 1; RG char c = getchar();
    for(; c < '0' || c > '9'; c = getchar()) z = c == '-' ? -1 : 1;
    for(; c >= '0' && c <= '9'; c = getchar()) x = (x << 1) + (x << 3) + (c ^ 48);
    return x * z;
}

Arr w;
struct Heap{
    priority_queue <int> A, B;

    IL void Push(RG int x){
        A.push(x);
    }

    IL void Del(RG int x){
        B.push(x);
    }

    IL int Top(){
        while(!B.empty() && B.top() == A.top()) A.pop(), B.pop();
        return A.empty() ? -INF : A.top();
    }
};

struct LCT{
    Arr fa, ch[2], mxv;
    Heap mx[_];

    IL int Son(RG int x){
        return ch[1][fa[x]] == x;
    }

    IL int Isroot(RG int x){
        return ch[0][fa[x]] != x && ch[1][fa[x]] != x;
    }

    IL void Update(RG int x){
        mxv[x] = max(max(mxv[ch[0][x]], mxv[ch[1][x]]), max(w[x], mx[x].Top()));
    }

    IL void Rotate(RG int x){
        RG int y = fa[x], z = fa[y], c = Son(x);
        if(!Isroot(y)) ch[Son(y)][z] = x; fa[x] = z;
        ch[c][y] = ch[!c][x], fa[ch[c][y]] = y;
        ch[!c][x] = y, fa[y] = x, Update(y);
    }

    IL void Splay(RG int x){
        for(RG int y = fa[x]; !Isroot(x); Rotate(x), y = fa[x])
            if(!Isroot(y)) Son(x) ^ Son(y) ? Rotate(x) : Rotate(y);
        Update(x);
    }

    IL void Access(RG int x){
        for(RG int y = 0; x; y = x, x = fa[x]){
            Splay(x);
            mx[x].Push(mxv[ch[1][x]]), mx[x].Del(mxv[y]);
            ch[1][x] = y, Update(x);
        }
    }

    IL int Findroot(RG int x){
        Access(x), Splay(x);
        while(ch[0][x]) x = ch[0][x];
        Splay(x);
        return x;
    }

    IL void Link(RG int x, RG int y){
        if(!y) return;
        Access(y), Splay(x), Splay(y);
        fa[x] = y, ch[1][y] = x, Update(y);
    }

    IL void Cut(RG int x, RG int y){
        if(!y) return;
        Access(x), Splay(x);
        ch[0][x] = fa[ch[0][x]] = 0, Update(x);
    }
} T[2];
Arr fa, col;
int n, m;
vector <int> G[_];

IL void Dfs(RG int u, RG int ff){
    for(RG int i = 0, l = G[u].size(); i < l; ++i){
        RG int v = G[u][i];
        if(v == ff) continue;
        T[col[v]].Link(v, u), fa[v] = u;
        Dfs(v, u);
    }
}

int main(RG int argc, RG char *argv[]){
    n = Input();
    for(RG int i = 1; i < n; ++i){
        RG int u = Input(), v = Input();
        G[u].push_back(v), G[v].push_back(u);
    }
    for(RG int i = 1; i <= n; ++i) col[i] = Input();
    for(RG int i = 1; i <= n; ++i) w[i] = Input();
    T[0].mxv[0] = T[1].mxv[0] = -INF;
    Dfs(1, 0), m = Input();
    for(RG int i = 1; i <= m; ++i){
        RG int op = Input(), x = Input(), ff, v, &c = col[x];
        if(op == 1) T[c].Cut(x, fa[x]), c ^= 1, T[c].Link(x, fa[x]);
        else if(op == 2){
            v = Input(), T[c].Access(x), T[c].Splay(x);
            w[x] = v, T[c].Update(x);
        }
        else{
            T[c].Access(x), ff = T[c].Findroot(x);
            if(col[ff] == c) printf("%d\n", T[c].mxv[ff]);
            else printf("%d\n", T[c].mxv[T[c].ch[1][ff]]);
        }
    }
    return 0;
}

原文地址:https://www.cnblogs.com/cjoieryl/p/8653038.html

时间: 2024-10-09 05:29:26

SPOJ QTREE7的相关文章

SPOJ QTREE7 lct

题目链接 已经在代码中注释了变量含义,感觉不难 inf好像不止|1e9| inf设成0x3f 才过.. #include <iostream> #include <fstream> #include <string> #include <time.h> #include <vector> #include <map> #include <queue> #include <algorithm> #include

【SPOJ】QTREE7(Link-Cut Tree)

[SPOJ]QTREE7(Link-Cut Tree) 题面 洛谷 Vjudge 题解 和QTREE6的本质是一样的:维护同色联通块 那么,QTREE6同理,对于两种颜色分别维护一棵\(LCT\) 每次只修改和它父亲的连边. 考虑如何维护最大值 因为每次\(access\)会删去一个数,所以我们肯定不能够只维护最大值. 因此,对于每一个节点,额外维护一个\(multiset\)(当然,可删堆,\(map\)之类的也行) 每次用\(multiset\)维护虚子树的最值,拿过去更新即可. 最后的答案

SPOJ 705 Distinct Substrings(后缀数组)

[题目链接] http://www.spoj.com/problems/SUBST1/ [题目大意] 给出一个串,求出不相同的子串的个数. [题解] 对原串做一遍后缀数组,按照后缀的名次进行遍历, 每个后缀对答案的贡献为n-sa[i]+1-h[i], 因为排名相邻的后缀一定是公共前缀最长的, 那么就可以有效地通过LCP去除重复计算的子串. [代码] #include <cstdio> #include <cstring> #include <algorithm> usi

SPOJ 3273

传送门: 这是一道treap的模板题,不要问我为什么一直在写模板题 依旧只放代码 1 //SPOJ 3273 2 //by Cydiater 3 //2016.8.31 4 #include <iostream> 5 #include <cstring> 6 #include <ctime> 7 #include <cmath> 8 #include <cstdlib> 9 #include <string> 10 #include

SPOJ CRAN02 - Roommate Agreement

题目链接:http://www.spoj.com/problems/CRAN02/ 题目大意:N个数字组成的序列,和为0的连续子序列的个数.N<1e6 解题思路:计算前缀和,统计每个数字出现的次数,那么对于数字sum[i], 如果存在k个sum[i],则代表有C(k, 2)个序列和为0,而如果sum[i] = 0,则还要累加上对应的k值. 代码: 1 ll n; 2 int a[maxn]; 3 ll sum[maxn]; 4 map<int, int> mmp; 5 6 void so

spoj GCJ1C09C Bribe the Prisoners

题目链接: http://www.spoj.com/problems/GCJ1C09C/ 题意: In a kingdom there are prison cells (numbered 1 to P) built to form a straight line segment. Cells number i and i+1 are adjacent, and prisoners in adjacent cells are called "neighbours." A wall wi

SPOJ QTREE Query on a tree ——树链剖分 线段树

[题目分析] 垃圾vjudge又挂了. 树链剖分裸题. 垃圾spoj,交了好几次,基本没改动却过了. [代码](自带常数,是别人的2倍左右) #include <cstdio> #include <cstring> #include <iostream> #include <algorithm> using namespace std; #define maxn 20005 int T,n,fr[maxn],h[maxn],to[maxn],ne[maxn]

BZOJ 2588: Spoj 10628. Count on a tree 主席树+lca

2588: Spoj 10628. Count on a tree Description 给定一棵N个节点的树,每个点有一个权值,对于M个询问(u,v,k),你需要回答u xor lastans和v这两个节点间第K小的点权.其中lastans是上一个询问的答案,初始为0,即第一个询问的u是明文. Input 第一行两个整数N,M. 第二行有N个整数,其中第i个整数表示点i的权值. 后面N-1行每行两个整数(x,y),表示点x到点y有一条边. 最后M行每行两个整数(u,v,k),表示一组询问.

BZOJ 1002 + SPOJ 104 基尔霍夫矩阵 + 一个递推式。

BZOJ 1002 高精度 + 递推 f[1] = 1; f[2] = 5; f[i] = f[i - 1] * 3 - f[i - 2] + 2; SPOJ 104 裸 + 不用Mod 1 #include <cstdio> 2 #include <cstring> 3 #include <cstdlib> 4 #include <algorithm> 5 #include <iostream> 6 7 using namespace std;